#auto_version

#import <shaders/include/instanced.glsl>
#import <shaders/include/rect_offsets.glsl>
#import <shaders/include/text.glsl>

// instance attributes
in vec2 Position;
in float Size;
in vec4 Color;
in uint Char;
in uint Flags;
/**
 * Atlas coordinate on the scale [0, 256).
 */
in ivec2 UVBase;
/**
 * In pixels.
 */
in ivec2 UVExtent;

out vec2 vUV;
out float vLocalV;
out vec4 vColor;
flat out float vBold;
flat out float vStrike;
flat out float vUnderline;

//const float BLEED_OFFSET = SUPER_PIXEL * 0.0;

void main() {
    vec2 offset = Offset;
    vec2 localPosition = offset;
    if (bool(Flags & FLAG_ITALIC)) {
        localPosition -= vec2(offset.y / 4.0, 0.0);
    }
    vec2 pos = fma(localPosition, vec2(Size), Position);
    gl_Position = projectPos(pos);

    applyClip(pos);

    uint ui = Char & uint(15);
    uint vi = Char >> uint(4);
    // the extent of each glyph texture in the atlas on the scale [0.0, 1.0]
    vec2 atlasExtent = vec2(UVExtent) / float(#atlas_size);
    // calculate the min coordinate of the glyph
    vUV = fma(vec2(ui, vi), atlasExtent, vec2(UVBase) / 256.0);
    // then calculate and add the vertex offset
//    vUV += fma(offset, atlasExtent - (BLEED_OFFSET * 2.0), vec2(BLEED_OFFSET));
    vUV += offset * atlasExtent;
    vLocalV = offset.y;
    vColor = Color;
    vBold = float(bool(Flags & FLAG_BOLD));
    vStrike = float(bool(Flags & FLAG_STRIKE));
    vUnderline = float(bool(Flags & FLAG_UNDERLINE));
}
